/*
* This file is part of the XKCD Velociraptor Simulation originally written by Matthew Beckler, Grant Miller, and John Saxton.
* 
* the XKCD Velociraptor Simulation is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
* 
* The XKCD Velociraptor Simulation is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with the XKCD Velociraptor Simulation; if not, write to the Free Software
* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
**/

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.imageio.*;
import java.awt.image.*;
import java.text.*;
import java.util.*;

public class MultipleRaptorSimulation
{
	private final static double STEP = .05;
	private DataPoint[] dataPoints;
	private boolean trails = false;
	private int numRaptors, numVictims;
	private ArrayList<Raptor> raptors;
	private ArrayList<Victim> victims;	
	private Random rand = new Random();
	public MultipleRaptorSimulation(boolean trails, int numRaptors, int numVictims)
	{
		this.trails = trails;
	}	
	public void setRaptors(int raptor)
	{
		raptors = new ArrayList(raptor);
		for (int i = 0; i < raptor; i++)
		{
			raptors.add(new Raptor(20+rand.nextInt(6), rand.nextInt(300), rand.nextInt(300)));
		}
	}
	public void setVictims(int victim)
	{
		victims = new ArrayList(victim);
		for (int i = 0; i < victim; i++)
			victims.add(new Victim(6, rand.nextInt(300), rand.nextInt(300), rand.nextInt(8) *  0.785398, 0.2));	
	}
	
	public void evaluate() //runners will have length of 80
	{
		//Due to the amount of time it would take to run 10 mutations on a test runner going in every 8 direction,
		//I am going to create a runner in each of the 8 directions and take the runner that got the furthest and run a mutation on him.
		//this function returns 
		boolean isDead;
		ArrayList<Raptor> testRaptors = new ArrayList();
		ArrayList<Victim> runners = new ArrayList();
		Victim steve = null;
		int furthestIndex = -1;
		double furthestTime = -1;
		Victim bestRunner;
		ArrayList<Victim> bestRunners = new ArrayList();
		for(int i = 0; i < victims.size(); i++)
		{
			bestRunners.add(victims.get(i));
		}
		//System.out.println(runners.size());
		for (Victim joe:victims) //test each runner, in order, i really hate joe
		{
			bestRunner = joe;
			testRaptors.removeAll(testRaptors);
			testRaptors = new ArrayList(joe.getThreats(raptors));
			runners = joe.getRunners();
			double time = 0.0;
			isDead = false;
			int numDead = 0;
			if (testRaptors.size() > 0)
			{
				numDead = 0;
				for(int i = 0; i < runners.size(); i++)
				{
					steve = runners.get(i);
					time = 0;
					isDead = false;
					while(!isDead)
					{
							for(Raptor raptor:testRaptors)
							{
								isDead = isDead || raptor.updatePosition(STEP, steve);
							}
						steve.updatePosition(STEP, steve);
						time += STEP;		
						if (time >=500)
							break;
					}					
					
					if (time > furthestTime + furthestTime * .25)
					{
						furthestTime = time;
						furthestIndex = i;
						bestRunner = runners.get(i);						
					}
					
					for(Raptor raptor:testRaptors)
						raptor.reset();
				}
				joe.decide(bestRunner.getTheta());	
			}
			joe.updatePosition(STEP, joe);
		}
		for (Raptor raptor: raptors)
		{
			if (raptor.updatePosition(STEP, victims))
				victims.remove(raptor.target);
		}
	}
	public ArrayList<Raptor> getRaptors()
	{
		return raptors;
	}
	public ArrayList<Victim> getVictims()
	{
		return victims;
	}

	public static int c2p(double coordinate)
	{
		return (int)((coordinate / 35.0) * 600.0) + 300;
	}
}

